/*	
	
Uniform ? 
			
Another Stupid Algorithm.
			
Version / 21 janvier 2011.	

*/

// -------------------------------------------------------------------------------------------------------------

#include "ext.h"							
#include "ext_obex.h"
#include "stdlib.h"
#include "math.h"	
#include "time.h"	
#include "ext_common.h"
#include "ext_systhread.h"
	
// -------------------------------------------------------------------------------------------------------------

#define TAILLE_VECTEUR_MAX	255
#define TAILLE_GRAF_MAX		750
#define MIN_INTERVAL		5
#define MAX_INTERVAL		10000
#define MIN_JUMP			1
#define MAX_JUMP			100

#define TEMPS_LOCK_DUMP		1000

#define TAILLE_ALPHABET		128
#define TAILLE_FIFO			1024
#define TAILLE_VRAC			1024
#define TAILLE_ULONG		32
#define TAILLE_BLOCS		32

#define DEF_GRAF_MAX		75
#define DEF_INTERVAL		250
#define DEF_JUMP			4

/*
	TAILLE_VRAC = TAILLE_ULONG * TAILLE_BLOCS
	TAILLE_FIFO = TAILLE_VRAC
*/

// -------------------------------------------------------------------------------------------------------------

typedef struct _noeud {
	ulong			parents[TAILLE_BLOCS] ;
	ulong			enfants[TAILLE_BLOCS] ;
	long			valeur ;
	long			terminal ;
	} t_noeud ;
	
// -------------------------------------------------------------------------------------------------------------

typedef struct _uniform {
	t_object		ob ;
	t_noeud			*vrac ;
	t_linklist		**graf ;
	long			*topo ;
	long			*fifo ;
	long			*vecteur ;
	long			*tirage ;
	long			index ;
	long			taille_vecteur ;
	long			taille_graf ;
	long			graf_pos ;
	long			head_fifo ;
	long			queue_fifo ;
	long			val_fifo ;
	long			interval ;
	long			graf_max ;
	long			jump ;
	long			lock_dump ;
	void			*m_clock1 ;
	void			*m_clock2 ;
	void			*m_out1 ;
	void			*m_out2 ;
	void			*m_out3 ;
	t_systhread_mutex   m_mutex ;
	} t_uniform ;
	
// -------------------------------------------------------------------------------------------------------------	
	
void		*uniform_new		(t_symbol *s, long argc, t_atom *argv) ;
long		uniform_init		(t_uniform *x) ;
void		uniform_free		(t_uniform *x) ;
void		uniform_assist		(t_uniform *x, void *b, long m, long a, char *s) ;
t_max_err	uniform_setcrossing (t_uniform *x, t_object *attr, long argc, t_atom *argv) ;
t_max_err	uniform_getcrossing (t_uniform *x, t_object *attr, long *argc, t_atom **argv) ;

void uniform_bang		(t_uniform *x) ;
void uniform_learn		(t_uniform *x, t_symbol *s, long argc, t_atom *argv) ;
void uniform_clear		(t_uniform *x) ;
void uniform_dump		(t_uniform *x) ;

void graf_effacer		(t_uniform *x) ;
void graf_ajouter		(t_uniform *x) ;
long graf_fusionner		(t_uniform *x) ;
void graf_task			(t_uniform *x) ;
long graf_avancer		(t_uniform *x) ;
long graf_arc_avancer	(t_uniform *x) ;
long graf_pos_init		(t_uniform *x) ;

void dump_task			(t_uniform *x) ;
void graf_dumpFun		(t_noeud *ptr, t_uniform *x) ;

void set_itemset		(ulong *ptr, long n) ;
void del_itemset		(ulong *ptr, long n) ;
long get_itemset		(ulong *ptr, long n) ;
void clear_itemset		(ulong *ptr) ;
long size_itemset		(ulong *ptr) ;
void mix_itemset		(ulong *ptrA, ulong *ptrB) ;

long put_fifo			(t_uniform *x, long n) ;
long get_fifo			(t_uniform *x) ;
void clear_fifo			(t_uniform *x) ;

// -------------------------------------------------------------------------------------------------------------

static t_class *uniform_class ;

int main (void)
	{	
		t_class *c = NULL ;
		
		c = class_new ("uniform", (method)uniform_new, (method)uniform_free, (long)sizeof(t_uniform), 0L, A_GIMME, 0) ;
		
		class_addmethod (c, (method)uniform_assist,		"assist", A_CANT, 0) ;
		class_addmethod (c, (method)uniform_learn,		"learn", A_GIMME, 0) ;
		class_addmethod (c, (method)uniform_dump,		"dump_max", 0) ;
		class_addmethod (c, (method)uniform_clear,		"clear", 0) ;
		class_addmethod (c, (method)uniform_bang,		"bang", 0) ;
		
		class_register (CLASS_BOX, c) ; 
		
		CLASS_ATTR_LONG			(c, "crossing",	ATTR_FLAGS_NONE, t_uniform, graf_max) ;
		CLASS_ATTR_LABEL		(c, "crossing",	ATTR_FLAGS_NONE, "Crossing Threshold") ;
		CLASS_ATTR_FILTER_CLIP	(c, "crossing",	2, TAILLE_GRAF_MAX) ;
		CLASS_ATTR_ACCESSORS	(c, "crossing", uniform_getcrossing, uniform_setcrossing) ;
		
		CLASS_ATTR_LONG			(c, "interval",	ATTR_FLAGS_NONE, t_uniform, interval) ;
		CLASS_ATTR_LABEL		(c, "interval",	ATTR_FLAGS_NONE, "Crossing Interval") ;
		CLASS_ATTR_FILTER_CLIP	(c, "interval",	MIN_INTERVAL, MAX_INTERVAL) ;
		
		CLASS_ATTR_LONG			(c, "jump",	ATTR_FLAGS_NONE, t_uniform, jump) ;
		CLASS_ATTR_LABEL		(c, "jump",	ATTR_FLAGS_NONE, "Terminal Jump of Death") ;
		CLASS_ATTR_FILTER_CLIP	(c, "jump",	MIN_JUMP, MAX_JUMP) ;
		
		uniform_class = c ;
		
		return 0 ;
	}

void *uniform_new (t_symbol *s, long argc, t_atom *argv)
	{
		t_uniform *x = NULL ;
		
		if (x = (t_uniform *)object_alloc (uniform_class)) 
			{	
				if (x->vrac = (t_noeud *)sysmem_newptrclear (sizeof(t_noeud) * TAILLE_VRAC))
					{
						srand (time(NULL)) ;

						x->head_fifo		= 0 ;
						x->queue_fifo		= 0 ;
						x->val_fifo			= 0 ;
						x->taille_vecteur	= 0 ;
						x->taille_graf		= 0 ;
						x->index			= 0 ;
						x->graf_pos			= -1 ;
						x->lock_dump		= 0 ;
						x->jump				= DEF_JUMP ;
						x->interval			= DEF_INTERVAL ;
						x->graf_max			= DEF_GRAF_MAX ;
						x->graf				= NULL ;
						x->fifo				= NULL ;
						x->vecteur			= NULL ;
						x->topo				= NULL ;
						x->tirage			= NULL ;
							
						x->m_out3 = intout ((t_object *)x) ;
						x->m_out2 = bangout ((t_object *)x) ;
						x->m_out1 = intout ((t_object *)x) ;
						
						x->m_clock2	= clock_new ((t_object *)x, (method)dump_task) ;
						x->m_clock1	= clock_new ((t_object *)x, (method)graf_task) ;
						
						systhread_mutex_new (&x->m_mutex, SYSTHREAD_MUTEX_NORMAL) ;
						
						if (!uniform_init (x))
							{
								object_free (x) ;
								x = NULL ;
							}
					}
				else
					{
						object_free (x) ;
						x = NULL ;
					}
			}
				
		return x ;
	}
	
long uniform_init (t_uniform *x)
	{
		x->vecteur	= (long *)sysmem_newptrclear (sizeof(long) * TAILLE_VECTEUR_MAX) ;
		x->topo		= (long *)sysmem_newptrclear (sizeof(long) * TAILLE_ALPHABET) ;
		x->tirage	= (long *)sysmem_newptrclear (sizeof(long) * TAILLE_VRAC) ;
			
		if (x->fifo	= (long *)sysmem_newptrclear (sizeof(long) * (TAILLE_FIFO + 1)))
			{
				long i ;
				
				for (i = 0 ; i < TAILLE_VRAC ; i++)
					{
						put_fifo (x, i) ;
					}
			}
		
		if (x->graf	= (t_linklist **)sysmem_newptrclear (sizeof(t_linklist *) * TAILLE_ALPHABET))
			{
				long i ;
				
				for (i = 0 ; i < TAILLE_ALPHABET ; i++)
					{
						if (x->graf[i] = linklist_new ( ))
							{
								linklist_flags (x->graf[i], OBJ_FLAG_REF) ;
							}
						else
							{
								goto error ;
							}
					}
			}
		
		return (x->vecteur && x->topo && x->tirage && x->fifo && x->graf ) ;
		
	error:	
	
		return 0 ;
	}

void uniform_free (t_uniform *x)
	{ 
		if (x->vecteur)
			{
				sysmem_freeptr (x->vecteur) ;
			}
		
		if (x->topo)
			{
				sysmem_freeptr (x->topo) ;
			}
		
		if (x->tirage)
			{
				sysmem_freeptr (x->tirage) ;
			}
			
		if (x->fifo)
			{
				sysmem_freeptr (x->fifo) ;
			}
		
		if (x->vrac)
			{
				sysmem_freeptr (x->vrac) ;
			}
		
		if (x->m_clock1)
			{
				clock_unset (x->m_clock1) ;
				object_free (x->m_clock1) ;
			}
		
		if (x->m_clock2)
			{
				clock_unset (x->m_clock2) ;
				object_free (x->m_clock2) ;
			}
		
		if (x->m_mutex)
			{
				systhread_mutex_free (x->m_mutex) ;
			}
		
		if (x->graf)
			{
				long i ;
				
				for (i = 0 ; i < TAILLE_ALPHABET ; i++)
					{
						if (x->graf[i])
							{
								object_free (x->graf[i]) ;
							}
					}
				
				sysmem_freeptr (x->graf) ;
			}
	}

void uniform_assist (t_uniform *x, void *b, long m, long a, char *s)
	{
		if (m == ASSIST_INLET) 
			{ 
				sprintf (s, "(bang) learn") ;
			} 
		else 
			{	
				switch (a) {
					case 0 :
						sprintf (s, "Navigate") ;
						break ;
					case 1 :
						sprintf (s, "Bang if empty") ;
						break ;
					case 2 :
						sprintf (s, "Number of Nodes") ;
						break ;
				}
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

t_max_err uniform_setcrossing (t_uniform *x, t_object *attr, long argc, t_atom *argv)
	{
		if (argc && argv)
			{
				x->graf_max = atom_getlong (argv) ;
				
				clock_fdelay (x->m_clock1, x->interval) ;
			}
			
		return MAX_ERR_NONE ;
	}
   
t_max_err uniform_getcrossing (t_uniform *x, t_object *attr, long *argc, t_atom **argv)
	{
		char alloc;
 
		atom_alloc (argc, argv, &alloc) ;     
		atom_setlong (*argv, x->graf_max) ;
	  
		return MAX_ERR_NONE ;
   }
   
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void uniform_bang (t_uniform *x)
	{
		long k = -1 ;
		
		if (x->taille_graf > 1)
			{
				systhread_mutex_lock (x->m_mutex) ;
		
				k = graf_avancer (x) ;
				
				systhread_mutex_unlock (x->m_mutex) ;
			}

		if (k != -1)
			{
				outlet_int (x->m_out1, k) ;
			}
		else
			{
				outlet_bang (x->m_out2) ;
			}
	}

void uniform_learn (t_uniform *x, t_symbol *s, long argc, t_atom *argv)
	{
		if (argc > 1)
			{
				if (!systhread_mutex_trylock (x->m_mutex)) 
					{
						long i ;
						
						x->taille_vecteur = (MIN (argc, TAILLE_VECTEUR_MAX)) ;
						
						for (i = 0 ; i < x->taille_vecteur ; i++)
							{
								if (atom_gettype (argv + i) == A_LONG)
									{
										x->vecteur[i] = CLIP (atom_getlong (argv + i), 0, (TAILLE_ALPHABET - 1)) ;
									}
								else
									{
										x->vecteur[i] = rand () % TAILLE_ALPHABET ;
									}
							}
						
						graf_ajouter (x) ;
						
						systhread_mutex_unlock (x->m_mutex) ;
					}
				
				clock_fdelay (x->m_clock1, x->interval) ; 
			}
		
		outlet_int (x->m_out3, x->taille_graf) ;
	}

void uniform_clear (t_uniform *x)
	{
		systhread_mutex_lock (x->m_mutex) ;

		graf_effacer (x) ;
		
		systhread_mutex_unlock (x->m_mutex) ;
		
		outlet_int (x->m_out3, x->taille_graf) ;
	}

void uniform_dump (t_uniform *x)
	{
		if (!x->lock_dump)
			{
				long i ;
				
				x->lock_dump = 1 ;
				
				post ("Nombre de noeuds : %ld / %ld", x->taille_graf, x->graf_max) ;
				post ("Intervalle fusion : %ld ms", x->interval) ; 
				post ("--") ;

				for (i = 0 ; i < TAILLE_ALPHABET ; i++)
					{
						linklist_funall (x->graf[i], (method)graf_dumpFun, x) ;
					}
					
				clock_fdelay (x->m_clock2, TEMPS_LOCK_DUMP) ;
			}
	}
	
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void graf_effacer (t_uniform *x) 
	{
		long i ;
		
		for (i = 0 ; i < TAILLE_ALPHABET ; i++)
			{
				linklist_clear (x->graf[i]) ;
				x->topo[i] = 0 ;
			}
			
		x->taille_graf	= 0 ;
		x->graf_pos		= -1 ;
		
		clear_fifo (x) ;
				
		for (i = 0 ; i < TAILLE_VRAC ; i++)
			{
				put_fifo (x, i) ;
			}
	}

void graf_ajouter (t_uniform *x)
	{
		if (get_fifo (x))
			{
				long	i ;
				long	a, b, k ;
				t_noeud *ptr = NULL ;
		
				k = x->vecteur[0] ;
				a = x->val_fifo ;
				
				clear_itemset (x->vrac[a].parents) ;
				clear_itemset (x->vrac[a].enfants) ;
				x->vrac[a].valeur = k ;
				x->vrac[a].terminal = 0 ;
				ptr = &x->vrac[a] ;
				linklist_append (x->graf[k], ptr) ;
				x->topo[k] ++ ;
				
				x->taille_graf ++ ;
				
				for (i = 1 ; i < x->taille_vecteur ; i++)
					{
						if (get_fifo (x))
							{
								k = x->vecteur[i] ;
								b = x->val_fifo ;
								
								clear_itemset (x->vrac[b].parents) ;
								clear_itemset (x->vrac[b].enfants) ;
								x->vrac[b].valeur = k ;
								x->vrac[b].terminal = 1 ;
								x->vrac[a].terminal = 0 ;
								ptr = &x->vrac[b] ;
								linklist_append (x->graf[k], ptr) ;
								x->topo[k] ++ ;
								
								x->taille_graf ++ ;
								
								set_itemset (x->vrac[a].enfants, b) ;
								set_itemset (x->vrac[b].parents, a) ;
								
								a = b ;
							}
					}
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

long graf_fusionner (t_uniform *x)
	{
		if (!systhread_mutex_trylock (x->m_mutex)) 
			{
				long i ;
				
				x->index = 0 ;
				
				for (i = 0 ; i < TAILLE_ALPHABET ; i++)
					{
						if (x->topo[i] > 1)
							{
								x->tirage[x->index] = i ;
								x->index ++ ;
							}
					}
				
				if (x->index)
					{
						long	j ;
						long	h, a, b ;
						t_noeud *ptrA = NULL ;
						t_noeud *ptrB = NULL ;			
							
						h = rand () % x->index ;
						a = rand () % x->topo[x->tirage[h]] ;
						
						do {
						b = rand () % x->topo[x->tirage[h]] ;
						} while (b == a) ;
										
						ptrA = linklist_getindex (x->graf[x->tirage[h]], a) ;
						ptrB = linklist_getindex (x->graf[x->tirage[h]], b) ;
						
						mix_itemset (ptrA->parents, ptrB->parents) ;
						mix_itemset (ptrA->enfants, ptrB->enfants) ;
						
						ptrA->terminal = ptrA->terminal || ptrB->terminal ;
						
						for (j = 0 ; j < TAILLE_VRAC ; j++)
							{
								if (get_itemset (ptrB->parents, j))
									{
										del_itemset (x->vrac[j].enfants, ptrB - x->vrac) ;
										set_itemset (x->vrac[j].enfants, ptrA - x->vrac) ;
									}
								
								if (get_itemset (ptrB->enfants, j))
									{
										del_itemset (x->vrac[j].parents, ptrB - x->vrac) ;
										set_itemset (x->vrac[j].parents, ptrA - x->vrac) ;
									}
							}
						
						del_itemset (ptrA->parents, ptrA - x->vrac) ;
						del_itemset (ptrA->enfants, ptrA - x->vrac) ;
						
						linklist_chuckindex (x->graf[x->tirage[h]], b) ;
						x->taille_graf -- ;
						put_fifo (x, ptrB - x->vrac) ;
						x->topo[x->tirage[h]] -- ;
						
						if (x->graf_pos == (ptrB - x->vrac))
							{
								x->graf_pos = ptrA - x->vrac ;
							}
					}
				
				systhread_mutex_unlock (x->m_mutex) ;
			}
		
		return !(x->index == 0) ;
	}

void graf_task (t_uniform *x)
	{
		if (x->taille_graf > x->graf_max)
			{
				if (graf_fusionner (x))
					{
						outlet_int (x->m_out3, x->taille_graf) ;
						
						clock_fdelay (x->m_clock1, x->interval) ; 
					}
			}
	}
	
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

long graf_avancer (t_uniform *x)
	{
		long k = -1 ;
		
		if (x->graf_pos == -1)
			{
				k = graf_pos_init (x) ;
			}
		else
			{
				if ((k = graf_arc_avancer (x)) == -1)
					{
						k = graf_pos_init (x) ;
					}
			}
			
		return k ;
	}

long graf_arc_avancer (t_uniform *x)
	{
		long k = -1 ;
		
		if (!(x->vrac[x->graf_pos].terminal && ((rand () % x->jump) == 0)))
			{
				long i ;
				
				x->index = 0 ;
				
				for (i = 0 ; i < TAILLE_VRAC ; i++)
					{
						if (get_itemset (x->vrac[x->graf_pos].enfants, i))
							{
								x->tirage[x->index] = i ;
								x->index ++ ;
							}
					}
				
				if (x->index)
					{
						long h ;
						
						h = rand () % x->index ;
						x->graf_pos = x->tirage[h] ;
						k = x->vrac[x->graf_pos].valeur ;
					}
			}
		
		return k ;
	}

long graf_pos_init (t_uniform *x)
	{
		long i ;
		long k = -1 ;
		
		x->index = 0 ;
		
		for (i = 0 ; i < TAILLE_ALPHABET ; i++)
			{
				if (x->topo[i])
					{
						x->tirage[x->index] = i ;
						x->index ++ ;
					}
			}
			
		if (x->index)
			{
				long	a, h ;
				t_noeud *ptr = NULL ;
				
				h = rand () % x->index ;
				a = rand () % x->topo[x->tirage[h]] ;
				
				ptr = linklist_getindex (x->graf[x->tirage[h]], a) ;
			
				x->graf_pos = ptr - x->vrac ;
				k = x->vrac[x->graf_pos].valeur ;
			}
		
		return k ;
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void dump_task (t_uniform *x)
	{
		x->lock_dump = 0 ;
	}
	
void graf_dumpFun (t_noeud *ptr, t_uniform *x)
   {
		long text_max = 50 ;
		char *affichage = NULL ;
		
		if (ptr->terminal) 
			{
				post ("Noeud : %ld       +", ptr - x->vrac) ;
			}
		else
			{
				post ("Noeud : %ld", ptr - x->vrac) ;
			}
			
		post ("    valeur : %ld", ptr->valeur) ;
		
		if (affichage = (char *)sysmem_newptr (sizeof(char) * text_max))
			{
				t_atomarray *q = NULL ;
				
				if (q = atomarray_new (0, NULL))
					{
						long	i ;
						long	ac ;
						t_atom	*p = NULL ;
						
						for (i = 0 ; i < TAILLE_VRAC ; i++)
							{
								if (get_itemset (ptr->parents, i))
									{
										t_atom a ;
										
										atom_setlong (&a, i) ;
										atomarray_appendatom (q, &a) ;
									}
							}
						
						atomarray_getatoms (q, &ac, &p) ;
						atom_gettext (ac, p, &text_max, &affichage, OBEX_UTIL_ATOM_GETTEXT_DEFAULT) ;
						
						if (ac)
							{
								post ("    parents : %s", affichage) ;
							}
						
						atomarray_clear (q) ;
						
						for (i = 0 ; i < TAILLE_VRAC ; i++)
							{
								if (get_itemset (ptr->enfants, i))
									{
										t_atom a ;
										
										atom_setlong (&a, i) ;
										atomarray_appendatom (q, &a) ;
									}
							}
						
						atomarray_getatoms (q, &ac, &p) ;
						atom_gettext (ac, p, &text_max, &affichage, OBEX_UTIL_ATOM_GETTEXT_DEFAULT) ;
						
						if (ac)
							{
								post ("    enfants : %s", affichage) ;
							}
						
						object_free (q) ;
					}
				
				sysmem_freeptr (affichage) ;
			}
   }
   	
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void set_itemset (ulong *ptr, long n) 
	{
		long i, p, m ;
		
		i = n / TAILLE_ULONG ;
		p = n % TAILLE_ULONG ;
		
		m = 1 << p ;
		
		*(ptr + i) |= m ;
	}

void del_itemset (ulong *ptr, long n) 
	{
		long i, p, m ;
		
		i = n / TAILLE_ULONG ;
		p = n % TAILLE_ULONG ;
		
		m = 1 << p ;
		
		*(ptr + i) &= ~m ;
	}
	
long get_itemset (ulong *ptr, long n) 
	{
		long	i, p ;
		ulong	temp ;
		
		i = n / TAILLE_ULONG ;
		p = n % TAILLE_ULONG ;
		
		temp = *(ptr + i) ;
	
		temp >>= p ;
		temp  &= 1 ;
		
		return temp != 0 ;
	}

void clear_itemset (ulong *ptr) 
	{
		long i ;
		
		for (i = 0 ; i < TAILLE_BLOCS ; i++)
			{
				*(ptr + i) = 0 ;
			}
	}
	
long size_itemset (ulong *ptr) 
	{
		long i ;
		long k = 0 ;
		
		for (i = 0 ; i < TAILLE_BLOCS ; i++)
			{
				ulong n = *(ptr + i) ;
				
				while (n != 0)
					{
						k  += (n & 1) ;
						n >>= 1 ;
					}
			}
		
		return k ;
	}

void mix_itemset (ulong *ptrA, ulong *ptrB) 
	{
		long i ;
		
		for (i = 0 ; i < TAILLE_BLOCS ; i++)
			{
				*(ptrA + i) |= *(ptrB + i) ;
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

long put_fifo (t_uniform *x, long n) 
	{	
		long k = 0 ;
		
		if (((x->queue_fifo + 1) != x->head_fifo) && !((x->queue_fifo == TAILLE_FIFO) && (x->head_fifo == 0)))
			{
				k = 1 ;
				
				x->fifo[x->queue_fifo] = n ;
				
				if (x->queue_fifo == TAILLE_FIFO)
					{
						x->queue_fifo = 0 ;
					}
				else
					{
						x->queue_fifo ++ ;
					}
			}
		
		return k ;
	}
	
long get_fifo (t_uniform *x)
	{
		long k = 0 ;
		
		if (x->head_fifo != x->queue_fifo)
			{
				k = 1 ;
				
				x->val_fifo = x->fifo[x->head_fifo] ;
				
				if (x->head_fifo == TAILLE_FIFO)
					{
						x->head_fifo = 0 ;
					}
				else
					{
						x->head_fifo ++ ;
					}
			}
		
		return k ;
	}
	
void clear_fifo (t_uniform *x)
	{
		x->head_fifo	= 0 ;
		x->queue_fifo	= 0 ;
		x->val_fifo		= 0 ;
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x